# coding: utf-8

import json
from java.util import Date
from java.text import SimpleDateFormat
from ru.curs.celesta.showcase.utils import XMLJSONConverter
from nci._nci_orm import personCursor
from edu._edu_orm import edu_group_personsCursor
from qt._qt_orm import QtiVariantAnswerCursor, QtiVariantCursor,\
    QtiVariantDestructorCursor, QtiVariantDestructorAnswerCursor, QtiVariantQuestionCursor,\
    QtiDestructorCursor, QtiQuestionCursor
from string import upper
try:
    from ru.curs.showcase.core.jython import JythonDTO
except:
    from ru.curs.celesta.showcase import JythonDTO

_persons_result = {}

def webtext(context, main=None, add=None, filterinfo=None, session=None, elementId=None):
    person_id = elementId
    webtextdata = {"student": {}}
    if not _persons_result.get(person_id):
        person_fio = u''
        person_name = u''
        person_surname = u''
        person_patronymic = u''
        variant_id = None
        testing_mark = None
        time_begin = None
        time_end = None
        time_finish = None
        time_remaining = u''
        positive_count = None
        score = None
        variant_name = None
        question_answered_count = 0
        question_positive_count = 0
        dateFormat = SimpleDateFormat("dd.MM.yyyy HH:mm")
        
        personCur = personCursor(context)
        if personCur.tryGet(person_id):
            person_fio = personCur.fullname
            person_name = personCur.name
            person_surname = personCur.surname
            person_patronymic = personCur.patronymic
        personCur.close()
        
        group_personsCur = edu_group_personsCursor(context)
        group_personsCur.setRange('group_id', main)
        group_personsCur.setRange('person_id', person_id)
        if group_personsCur.tryFirst():
            variant_id = group_personsCur.variant_id
        group_personsCur.close()
        
        if variant_id:
            variantCur = QtiVariantCursor(context)
            if variantCur.tryGet(variant_id):
                variant_name = variantCur.VariantName
            variantCur.close()
            
            variantCur = QtiVariantAnswerCursor(context)
            variantCur.setRange('VariantID', variant_id) 
            if variantCur.tryFirst():
                testing_mark = variantCur.TestingMark
                time_begin = variantCur.TimeBegin
                time_end = variantCur.TimeEnd
                time_finish = variantCur.TimeFinish
                time_now = Date()
                if (not time_finish) and (time_now <= time_end):
                    t = (time_end.getTime() - time_now.getTime()) / 60000
                    h = t // 60
                    m = t % 60
                    hh = u'{} час'.format(h) if h>0 else u'' 
                    mm = u'{} мин'.format(m) if m>0 else u''
                    time_remaining = u'{} {}'.format(hh, mm)
                score = variantCur.Score
                positive_count = variantCur.PositiveCount
            variantCur.close()
            if time_finish:
                
                question_positive_count = positive_count
                time_remaining = u'Тест завершён'
               
                QtiVariantDestructor = QtiVariantDestructorCursor(context)
                QtiVariantDestructorAnswer = QtiVariantDestructorAnswerCursor(context)
                QtiVariantQuestionCur = QtiVariantQuestionCursor(context)
                QtiVariantQuestionCur.setRange('VariantID', variant_id)
                
                for QtiVariantQuestion in QtiVariantQuestionCur.iterate():
                    question_answered = False
                    QtiVariantDestructor.setRange('VariantQuestionID', QtiVariantQuestion.VariantQuestionID)
                    for QtiVariantDestructor in QtiVariantDestructor.iterate():
                        QtiVariantDestructorAnswer.setRange('VariantDestructorID', QtiVariantDestructor.VariantDestructorID)
                        if QtiVariantDestructorAnswer.tryFirst():
                            question_answered = True
                            break
                    if question_answered:
                        question_answered_count += 1
                
                QtiVariantQuestionCur.close()
                QtiVariantDestructorAnswer.close()
                QtiVariantDestructor.close()
                
                _persons_result[person_id] = {
                        "fio": person_fio,
                        "surname": upper(person_surname) if person_surname else u'',
                        "name": person_name,
                        "patronymic": person_patronymic,
                        "variant": variant_name,
                        "testing_mark": testing_mark,
                        "time_begin": dateFormat.format(time_begin) if time_begin else '',
                        "time_remaining": time_remaining,
                        "time_end": dateFormat.format(time_end) if time_end else '',
                        "time_finish": dateFormat.format(time_finish) if time_finish else '',
                        "positive_count": positive_count,
                        "question_positive_count": question_positive_count,
                        "question_answered_count": question_answered_count,
                        "score": score}
            else:
                QtiVariantQuestionCur = QtiVariantQuestionCursor(context)
                QtiVariantQuestionCur.setRange('VariantID', variant_id)
                for QtiVariantQuestion in QtiVariantQuestionCur.iterate():
                    if QtiVariantQuestion.HasAnswer:
                        question_answered_count += 1
                    if QtiVariantQuestion.CorrectAnswer:
                        question_positive_count += 1
                QtiVariantQuestionCur.close()

#                 QtiVariantDestructor = QtiVariantDestructorCursor(context)
#                 QtiVariantDestructorAnswer = QtiVariantDestructorAnswerCursor(context)
#                 QtiVariantQuestionCur = QtiVariantQuestionCursor(context)
#                 QtiVariantQuestionCur.setRange('VariantID', variant_id)
#                 QtiDestructor = QtiDestructorCursor(context)
# #                 QtiQuestion = QtiQuestionCursor(context)
#         
#                 # Цикл по вопросам тестирования
#                 for QtiVariantQuestion in QtiVariantQuestionCur.iterate():
#                     checkFlag = True
#                     question_answered = False
#                     question_id = QtiVariantQuestion.QuestionID
#                     # Очистка курсоров для корректной работы
#                     QtiDestructor.clear()
#                     QtiVariantDestructor.clear()
# #                     QtiQuestion.get(QtiVariantQuestion.QuestionID)
# #                     question_type = QtiQuestion.QuestionType
#                     question_type = QtiVariantQuestion.QuestionType
#                     
#                     # Вопросы с одиночным или множественным выбором
#                     if question_type == 1 or question_type == 2:
#                         # Правильные ответы хранятся в QtiDestructor и у правильных ответов поле isTrue равно True
#                         QtiDestructor.setRange('QuestionID', question_id)
#                         QtiDestructor.setRange('IsTrue', True)
#                         answerList = []
#                         # Формируе список правильных вариантов отвтов
#                         for QtiDestructor in QtiDestructor.iterate():
#                             answerList.append(QtiDestructor.DestructorID)
#                         
#                         QtiVariantDestructor.setRange('VariantQuestionID', QtiVariantQuestion.VariantQuestionID)
#                         # Цикл по вариантам ответов слушателя
#                         for QtiVariantDestructor in QtiVariantDestructor.iterate():
#                             QtiVariantDestructorAnswer.setRange('VariantDestructorID', QtiVariantDestructor.VariantDestructorID)
#                             # Если слушатель в ходе  тестирования выбрал вариант текущий вариант, то запись об этом будет в таблице QtiVariantDestructorAnswer
#                             if QtiVariantDestructorAnswer.tryFirst():
#                                 question_answered = True
#                                 # Если слушатель выбрал вариант, которого нет в списке правильных, то вопрос не засчитывается
#                                 if QtiVariantDestructor.DestructorID not in answerList:
#                                     checkFlag = False
#                                 else:
#                                     # Если слушатель выбрал правльный вариант, то удаляем этот вариант из списка правальных
#                                     answerList.remove(QtiVariantDestructor.DestructorID)
#                         # Список правильных ответов будет непуст, если слушатель не указал какой-либо правильный вариант, следовательно, вопрос не засчитывается 
#                         if answerList != []:
#                             checkFlag = False
#                     # Вопросы с текстовым ответом
#                     elif question_type == 3:
#                         QtiDestructor.setRange('QuestionID', question_id)
#                         QtiDestructor.first()
#                         # Правильный ответ хранится в таблице QtiDestructor в полу DestructorHtml. Для вопросов такого типа в QtiDestructor только одна запись соответствует вопросу
#                         correctAnswer = QtiDestructor.DestructorHtml
#                         
#                         QtiVariantDestructor.setRange('VariantQuestionID', QtiVariantQuestion.VariantQuestionID)
#                         QtiVariantDestructor.first()
#                         
#                         QtiVariantDestructorAnswer.setRange('VariantDestructorID', QtiVariantDestructor.VariantDestructorID)
#                         # Получаем ответ на вопрос, данный слушателем
#                         if QtiVariantDestructorAnswer.tryFirst():
#                             question_answered = True
#                             # Если ответв на вопрос не совпадает с верным, то вопрос не засчитывается
#                             if QtiVariantDestructorAnswer.DestructorText != correctAnswer:
#                                 checkFlag = False                   
#                         else:
#                             # Если ответа нет, то вопрос не засчитывается
#                             checkFlag = False
#                     # Вопрос-сопоставление
#                     elif question_type == 4:
#                         # Для вопросов-сопоставлений в таблице QtiDestructor в полях DestructorHtml и DestructorHtml2 хранятся значение из левой колонки,
#                         # в поле AnswerText правильное значений их правой колонки. В QtiDestructorAnswer для каждого варианта в поле DestructorID пишется id,
#                         # того варианта значение из правой колонки которого было помещено в соответствие текущему варианту.
#                         QtiVariantDestructor.setRange('VariantQuestionID', QtiVariantQuestion.VariantQuestionID)
#                         for QtiVariantDestructor in QtiVariantDestructor.iterate():
#                             QtiVariantDestructorAnswer.setRange('VariantDestructorID', QtiVariantDestructor.VariantDestructorID)
#                             if QtiVariantDestructorAnswer.tryFirst():
#                                 question_answered = True
#                                 if QtiVariantDestructorAnswer.DestructorID != QtiVariantDestructor.DestructorID:
#                                     checkFlag = False
#                             else:
#                                 checkFlag = False
#                     # Вопрос-сортировка
#                     elif question_type == 5:
#                         # В QtiDestructor правильный порядок задаётся полем DestructorOrder. В QtiVariantDestructorAnswer  в поле DestructorText заносится номер выбранной строки
#                         QtiVariantDestructor.setRange('VariantQuestionID', QtiVariantQuestion.VariantQuestionID)
#                         for QtiVariantDestructor in QtiVariantDestructor.iterate():
#                             QtiDestructor.get(QtiVariantDestructor.DestructorID)
#                             QtiVariantDestructorAnswer.setRange('VariantDestructorID', QtiVariantDestructor.VariantDestructorID)
#                             if QtiVariantDestructorAnswer.tryFirst():
#                                 question_answered = True
#                                 if int(QtiDestructor.DestructorOrder) != int(QtiVariantDestructorAnswer.DestructorText):
#                                     checkFlag = False
#                             else:
#                                 checkFlag = False
#                     # Вопрос-классификация
#                     elif question_type == 6:
#                         # Ответы хранятся аналогично вопросу-сопоставлению
#                         QtiVariantDestructor.setRange('VariantQuestionID', QtiVariantQuestion.VariantQuestionID)
#                         for QtiVariantDestructor in QtiVariantDestructor.iterate():
#                             QtiDestructor.get(QtiVariantDestructor.DestructorID)
#                             correctAnswer = QtiDestructor.AnswerText
#                             QtiVariantDestructorAnswer.setRange('VariantDestructorID', QtiVariantDestructor.VariantDestructorID)
#                             if QtiVariantDestructorAnswer.tryFirst():
#                                 question_answered = True
#                                 QtiDestructor.get(QtiVariantDestructorAnswer.DestructorID)
#                                 if QtiDestructor.AnswerText != correctAnswer:
#                                     checkFlag = False
#                             else:
#                                 checkFlag = False
#                     # Если ответ правильный, увеличиваем счётчик правильных ответов, в таблицу пишем что на вопрос был дан правильный ответ
#                     if checkFlag:
#                         question_positive_count += 1
#                     if question_answered:
#                         question_answered_count += 1
#                         
# #                 QtiQuestion.close()
#                 QtiDestructor.close()        
#                 QtiVariantQuestionCur.close()
#                 QtiVariantDestructorAnswer.close()
#                 QtiVariantDestructor.close()
     
        webtextdata["student"] = {
                    "fio": person_fio,
                    "surname": upper(person_surname) if person_surname else u'',
                    "name": person_name,
                    "patronymic": person_patronymic,
                    "variant": variant_name,
                    "testing_mark": testing_mark,
                    "time_begin": dateFormat.format(time_begin) if time_begin else '',
                    "time_remaining": time_remaining,
                    "time_end": dateFormat.format(time_end) if time_end else '',
                    "time_finish": dateFormat.format(time_finish) if time_finish else '',
                    "positive_count": positive_count,
                    "question_positive_count": question_positive_count,
                    "question_answered_count": question_answered_count,
                    "score": score}
    else:
        webtextdata["student"] = _persons_result.get(person_id)
        
    webtextsettings = {"properties": {}}

    settings = XMLJSONConverter.jsonToXml(json.dumps(webtextsettings))
    data = XMLJSONConverter.jsonToXml(json.dumps(webtextdata))

    return JythonDTO(data, settings)
